diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/random-walk-2d-outdoor-mobility-model.h ns-3.31/src/buildings/model/random-walk-2d-outdoor-mobility-model.h
--- ns-3.30.1/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,135 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2006,2007 INRIA
+ * Copyright (c) 2019 University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Author: Michele Polese <michele.polese@gmail.com>
+ */
+
+#ifndef RANDOM_WALK_2D_OUTDOOR_MOBILITY_MODEL_H
+#define RANDOM_WALK_2D_OUTDOOR_MOBILITY_MODEL_H
+
+#include "ns3/object.h"
+#include "ns3/nstime.h"
+#include "ns3/event-id.h"
+#include "ns3/rectangle.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/mobility-model.h"
+#include "ns3/constant-velocity-helper.h"
+#include "ns3/building.h"
+
+namespace ns3 {
+
+
+/**
+ * \ingroup mobility
+ * \brief 2D random walk mobility model which avoids buildings.
+ *
+ * This class reuses most of the code of RandomWalk2dMobilityModel,
+ * but adds the awareness of buildings objects which are avoided
+ * by moving users.
+ * Each instance moves with a speed and direction chosen at random
+ * with the user-provided random variables until
+ * either a fixed distance has been walked or until a fixed amount
+ * of time. If we hit one of the boundaries (specified by a rectangle)
+ * of the model, we rebound on the boundary with a reflexive angle
+ * and speed. If we hit one of the buildings, we rebound with a random
+ * direction which makes sure that the next step does not enter the building.
+ *
+ * The default values for the random variable that describes the speed is
+ * taken from Figure 1 in the paper:
+ * Henderson, L.F., 1971. The statistics of crowd fluids. nature, 229(5284), p.381.
+ */
+class RandomWalk2dOutdoorMobilityModel : public MobilityModel
+{
+public:
+  /**
+   * Register this type with the TypeId system.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  /** An enum representing the different working modes of this module. */
+  enum Mode
+  {
+    MODE_DISTANCE,
+    MODE_TIME
+  };
+
+private:
+  /**
+   * \brief Performs the rebound of the node if it reaches a boundary
+   * \param timeLeft The remaining time of the walk
+   */
+  void Rebound (Time timeLeft);
+  /**
+   * \brief Avoid a building
+   * \param timeLeft The remaining time of the walk
+   * \param intersectPosition The position at which the building is intersected
+   */
+  void AvoidBuilding (Time delayLeft, Vector intersectPosition);
+  /**
+   * Walk according to position and velocity, until distance is reached,
+   * time is reached, or intersection with the bounding box, or building
+   */
+  void DoWalk (Time timeLeft);
+  /**
+   * Perform initialization of the object before MobilityModel::DoInitialize ()
+   */
+  void DoInitializePrivate (void);
+  /**
+   * Check if there is a building between two positions (or if the nextPosition is inside a building).
+   * The code is taken from MmWave3gppBuildingsPropagationLossModel from the NYU/UNIPD ns-3 mmWave module
+   * \param currentPosition The current position of the node
+   * \param nextPosition The position to check
+   * \return a pair with a boolean (true if the line between the two position does not intersect building),
+   * and a pointer which is 0 if the boolean is true, or it points to the building which is intersected
+   */
+  std::pair<bool, Ptr<Building> > IsLineClearOfBuildings (Vector currentPosition, Vector nextPosition ) const;
+  /**
+   * Compute the intersecting point of the box represented by boundaries and the line between current and next
+   * Notice that we only consider a 2d plane
+   * \param current The current position
+   * \param next The next position
+   * \param boundaries The boundaries of the building we will intersect
+   * \return a vector with the position of the intersection
+   */
+  Vector CalculateIntersectionFromOutside (const Vector &current, const Vector &next, const Box boundaries) const;
+
+  virtual void DoDispose (void);
+  virtual void DoInitialize (void);
+  virtual Vector DoGetPosition (void) const;
+  virtual void DoSetPosition (const Vector &position);
+  virtual Vector DoGetVelocity (void) const;
+  virtual int64_t DoAssignStreams (int64_t);
+
+  ConstantVelocityHelper m_helper; //!< helper for this object
+  EventId m_event; //!< stored event ID
+  enum Mode m_mode; //!< whether in time or distance mode
+  double m_modeDistance; //!< Change direction and speed after this distance
+  Time m_modeTime; //!< Change current direction and speed after this delay
+  Ptr<RandomVariableStream> m_speed; //!< rv for picking speed
+  Ptr<RandomVariableStream> m_direction; //!< rv for picking direction
+  Rectangle m_bounds; //!< Bounds of the area to cruise
+  double m_epsilon; //!< Tolerance for the intersection point with buildings
+  uint32_t m_maxIter; //!< Maximum number of tries to find the next position
+  Vector m_prevPosition; //!< Store the previous position in case a step back is needed
+};
+
+
+} // namespace ns3
+
+#endif /* RANDOM_WALK_2D_OUTDOOR_MOBILITY_MODEL_H */
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/building-position-allocator-test.cc ns-3.31/src/buildings/test/building-position-allocator-test.cc
--- ns-3.30.1/src/buildings/test/building-position-allocator-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/test/building-position-allocator-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -101,8 +101,6 @@
   mobility.Install (nodes);
   BuildingsHelper::Install (nodes);
 
-  BuildingsHelper::MakeMobilityModelConsistent ();
-
   std::map<Room, uint32_t> roomCounter;
 
   for (NodeContainer::Iterator it = nodes.Begin (); it != nodes.End (); ++it)
@@ -190,8 +188,6 @@
   mobility.Install (copyNodes);
   BuildingsHelper::Install (copyNodes);
 
-  BuildingsHelper::MakeMobilityModelConsistent ();
-
   std::map<Room, uint32_t> roomCounter;
 
   for (NodeContainer::Iterator it = copyNodes.Begin (); it != copyNodes.End (); ++it)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/buildings-channel-condition-model-test.cc ns-3.31/src/buildings/test/buildings-channel-condition-model-test.cc
--- ns-3.30.1/src/buildings/test/buildings-channel-condition-model-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/test/buildings-channel-condition-model-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,157 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "ns3/abort.h"
+#include "ns3/test.h"
+#include "ns3/config.h"
+#include "ns3/buildings-channel-condition-model.h"
+#include "ns3/constant-position-mobility-model.h"
+#include "ns3/buildings-module.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("BuildingsChannelConditionModelsTest");
+
+/**
+ * Test case for the class BuildingsChannelConditionModel. It checks if the
+ * channel condition is correctly determined when a building is deployed in the
+ * scenario
+ */
+class BuildingsChannelConditionModelTestCase : public TestCase
+{
+public:
+  /**
+   * Constructor
+   */
+  BuildingsChannelConditionModelTestCase ();
+
+  /**
+   * Destructor
+   */
+  virtual ~BuildingsChannelConditionModelTestCase ();
+
+private:
+  /**
+   * Builds the simulation scenario and perform the tests
+   */
+  virtual void DoRun (void);
+
+  /**
+   * Struct containing the parameters for each test
+   */
+  typedef struct
+  {
+    Vector m_positionA; //!< the position of the first node
+    Vector m_positionB; //!< the position of the second node
+    ChannelCondition::LosConditionValue m_losCond; //!< the correct channel condition
+  } TestVector;
+
+  TestVectors<TestVector> m_testVectors; //!< array containg all the test vectors
+};
+
+BuildingsChannelConditionModelTestCase::BuildingsChannelConditionModelTestCase ()
+  : TestCase ("Test case for the BuildingsChannelConditionModel"), m_testVectors ()
+{
+}
+
+BuildingsChannelConditionModelTestCase::~BuildingsChannelConditionModelTestCase ()
+{
+}
+
+void
+BuildingsChannelConditionModelTestCase::DoRun (void)
+{
+  TestVector testVector;
+
+  testVector.m_positionA = Vector (0.0, 5.0, 1.5);
+  testVector.m_positionB = Vector (20.0, 5.0, 1.5);
+  testVector.m_losCond = ChannelCondition::LosConditionValue::NLOS;
+  m_testVectors.Add (testVector);
+
+  testVector.m_positionA = Vector (0.0, 11.0, 1.5);
+  testVector.m_positionB = Vector (20.0, 11.0, 1.5);
+  testVector.m_losCond = ChannelCondition::LosConditionValue::LOS;
+  m_testVectors.Add (testVector);
+
+  testVector.m_positionA = Vector (5.0, 5.0, 1.5);
+  testVector.m_positionB = Vector (20.0, 5.0, 1.5);
+  testVector.m_losCond = ChannelCondition::LosConditionValue::NLOS;
+  m_testVectors.Add (testVector);
+
+  testVector.m_positionA = Vector (4.0, 5.0, 1.5);
+  testVector.m_positionB = Vector (5.0, 5.0, 1.5);
+  testVector.m_losCond = ChannelCondition::LosConditionValue::LOS;
+  m_testVectors.Add (testVector);
+
+  // Deploy nodes and building and get the channel condition
+  NodeContainer nodes;
+  nodes.Create (2);
+
+  Ptr<MobilityModel> a = CreateObject<ConstantPositionMobilityModel> ();
+  nodes.Get (0)->AggregateObject (a);
+
+  Ptr<MobilityModel> b = CreateObject<ConstantPositionMobilityModel> ();
+  nodes.Get (1)->AggregateObject (b);
+
+  Ptr<BuildingsChannelConditionModel> condModel = CreateObject<BuildingsChannelConditionModel> ();
+
+  Ptr<Building> building = Create<Building> ();
+  building->SetNRoomsX (1);
+  building->SetNRoomsY (1);
+  building->SetNFloors (1);
+  building->SetBoundaries (Box (0.0, 10.0, 0.0, 10.0, 0.0, 5.0));
+
+  BuildingsHelper::Install (nodes);
+
+  for (uint32_t i = 0; i < m_testVectors.GetN (); ++i)
+    {
+      testVector = m_testVectors.Get (i);
+      a->SetPosition (testVector.m_positionA);
+      b->SetPosition (testVector.m_positionB);
+      Ptr<MobilityBuildingInfo> buildingInfoA = a->GetObject<MobilityBuildingInfo> ();
+      buildingInfoA->MakeConsistent (a);
+      Ptr<MobilityBuildingInfo> buildingInfoB = b->GetObject<MobilityBuildingInfo> ();
+      buildingInfoA->MakeConsistent (b);
+      Ptr<ChannelCondition> cond = condModel->GetChannelCondition (a, b);
+
+      NS_LOG_DEBUG ("Got " << cond->GetLosCondition () << " expected condition " << testVector.m_losCond);
+      NS_TEST_ASSERT_MSG_EQ (cond->GetLosCondition (), testVector.m_losCond, " Got unexpected channel condition");
+    }
+
+  Simulator::Destroy ();
+}
+
+/**
+ * Test suite for the buildings channel condition model
+ */
+class BuildingsChannelConditionModelsTestSuite : public TestSuite
+{
+public:
+  BuildingsChannelConditionModelsTestSuite ();
+};
+
+BuildingsChannelConditionModelsTestSuite::BuildingsChannelConditionModelsTestSuite ()
+  : TestSuite ("buildings-channel-condition-model", UNIT)
+{
+  AddTestCase (new BuildingsChannelConditionModelTestCase, TestCase::QUICK);
+}
+
+static BuildingsChannelConditionModelsTestSuite BuildingsChannelConditionModelsTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/buildings-helper-test.cc ns-3.31/src/buildings/test/buildings-helper-test.cc
--- ns-3.30.1/src/buildings/test/buildings-helper-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/test/buildings-helper-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -150,7 +150,6 @@
   b->SetNRoomsY (m_bd.nry);
   Ptr<MobilityBuildingInfo> buildingInfo = CreateObject<MobilityBuildingInfo> (b);
   bmm->AggregateObject (buildingInfo); // operation usually done by BuildingsHelper::Install
-  BuildingsHelper::MakeMobilityModelConsistent ();
 
   
   NS_TEST_ASSERT_MSG_EQ (buildingInfo->IsIndoor (), m_pib.indoor, "indoor/outdoor mismatch");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/buildings-pathloss-test.cc ns-3.31/src/buildings/test/buildings-pathloss-test.cc
--- ns-3.30.1/src/buildings/test/buildings-pathloss-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/test/buildings-pathloss-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -267,6 +267,6 @@
     }
   Ptr<MobilityBuildingInfo> buildingInfo = CreateObject<MobilityBuildingInfo> ();
   mm->AggregateObject (buildingInfo); // operation usually done by BuildingsHelper::Install
-  BuildingsHelper::MakeConsistent (mm); 
+  buildingInfo->MakeConsistent (mm);
   return mm;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/buildings-shadowing-test.cc ns-3.31/src/buildings/test/buildings-shadowing-test.cc
--- ns-3.30.1/src/buildings/test/buildings-shadowing-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/test/buildings-shadowing-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -223,6 +223,6 @@
     }
   Ptr<MobilityBuildingInfo> buildingInfo = CreateObject<MobilityBuildingInfo> ();
   mm->AggregateObject (buildingInfo); // operation usually done by BuildingsHelper::Install
-  BuildingsHelper::MakeConsistent (mm); 
+  buildingInfo->MakeConsistent (mm);
   return mm;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/test/outdoor-random-walk-test.cc ns-3.31/src/buildings/test/outdoor-random-walk-test.cc
--- ns-3.30.1/src/buildings/test/outdoor-random-walk-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/test/outdoor-random-walk-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,167 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "ns3/abort.h"
+#include "ns3/test.h"
+#include "ns3/config.h"
+#include "ns3/building.h"
+#include "ns3/building-position-allocator.h"
+#include "ns3/random-walk-2d-outdoor-mobility-model.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+#include "ns3/double.h"
+#include "ns3/pointer.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("OutdoorRandomWalkTest");
+
+/**
+ * Test case for the class OutdoorRandomWalkTestCase. It checks if the
+ * positions visited by the user are outside buildings
+ */
+class OutdoorRandomWalkTestCase : public TestCase
+{
+public:
+  /**
+   * Constructor
+   */
+  OutdoorRandomWalkTestCase ();
+
+  /**
+   * Destructor
+   */
+  virtual ~OutdoorRandomWalkTestCase ();
+
+private:
+  /**
+   * Builds the simulation scenario and perform the tests
+   */
+  virtual void DoRun (void);
+
+  void CheckPositionOutdoor (Ptr<RandomWalk2dOutdoorMobilityModel> model);
+
+  std::vector<Ptr<Building> > m_buildings;
+};
+
+OutdoorRandomWalkTestCase::OutdoorRandomWalkTestCase ()
+  : TestCase ("Test case for the BuildingsChannelConditionModel"), m_buildings ()
+{}
+
+OutdoorRandomWalkTestCase::~OutdoorRandomWalkTestCase ()
+{}
+
+void
+OutdoorRandomWalkTestCase::CheckPositionOutdoor (Ptr<RandomWalk2dOutdoorMobilityModel> model)
+{
+  auto position = model->GetPosition ();
+  for (auto building : m_buildings)
+    {
+      NS_TEST_ASSERT_MSG_EQ (building->IsInside (position), false, "Position " << position << " is inside");
+    }
+}
+
+void
+OutdoorRandomWalkTestCase::DoRun (void)
+{
+  // create a grid of buildings
+  double buildingSizeX = 100; // m
+  double buildingSizeY = 50; // m
+  double streetWidth = 25; // m
+  double buildingHeight = 10; // m
+  uint32_t numBuildingsX = 20;
+  uint32_t numBuildingsY = 20;
+  double maxAxisX = (buildingSizeX + streetWidth) * numBuildingsX;
+  double maxAxisY = (buildingSizeY + streetWidth) * numBuildingsY;
+
+  for (uint32_t buildingIdX = 0; buildingIdX < numBuildingsX; ++buildingIdX)
+    {
+      for (uint32_t buildingIdY = 0; buildingIdY < numBuildingsY; ++buildingIdY)
+        {
+          Ptr < Building > building;
+          building = CreateObject<Building> ();
+
+          building->SetBoundaries (Box (buildingIdX * (buildingSizeX + streetWidth),
+                                        buildingIdX * (buildingSizeX + streetWidth) + buildingSizeX,
+                                        buildingIdY * (buildingSizeY + streetWidth),
+                                        buildingIdY * (buildingSizeY + streetWidth) + buildingSizeY,
+                                        0.0, buildingHeight));
+          building->SetNRoomsX (1);
+          building->SetNRoomsY (1);
+          building->SetNFloors (1);
+          m_buildings.push_back (building);
+        }
+    }
+
+  // create one node
+  NodeContainer nodes;
+  nodes.Create (1);
+
+  // set the RandomWalk2dOutdoorMobilityModel mobility model
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::RandomWalk2dOutdoorMobilityModel",
+                             "Bounds", RectangleValue (
+                               Rectangle (-streetWidth, maxAxisX, -streetWidth, maxAxisY)));
+  // create an OutdoorPositionAllocator and set its boundaries to match those of the mobility model
+  Ptr<OutdoorPositionAllocator> position = CreateObject<OutdoorPositionAllocator> ();
+  Ptr<UniformRandomVariable> xPos = CreateObject<UniformRandomVariable>();
+  xPos->SetAttribute ("Min", DoubleValue (-streetWidth));
+  xPos->SetAttribute ("Max", DoubleValue (maxAxisX));
+  Ptr<UniformRandomVariable> yPos = CreateObject<UniformRandomVariable>();
+  yPos->SetAttribute ("Min", DoubleValue (-streetWidth));
+  yPos->SetAttribute ("Max", DoubleValue (maxAxisY));
+  position->SetAttribute ("X", PointerValue (xPos));
+  position->SetAttribute ("Y", PointerValue (yPos));
+  mobility.SetPositionAllocator (position);
+  // install the mobility model
+  mobility.Install (nodes.Get (0));
+
+  auto mobilityModel = nodes.Get (0)->GetObject<RandomWalk2dOutdoorMobilityModel>();
+
+  // get maxChecks positions, check if they are outdoors
+  double testStep = 10; // s
+  int maxChecks = 1000;
+  for (int i = 0; i < maxChecks; ++i)
+    {
+      Simulator::Schedule (Seconds (i * testStep),
+                           &OutdoorRandomWalkTestCase::CheckPositionOutdoor, this, mobilityModel);
+    }
+
+  Simulator::Stop (Seconds (maxChecks * testStep + 1));
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+/**
+ * Test suite for the buildings channel condition model
+ */
+class OutdoorRandomWalkTestSuite : public TestSuite
+{
+public:
+  OutdoorRandomWalkTestSuite ();
+};
+
+OutdoorRandomWalkTestSuite::OutdoorRandomWalkTestSuite ()
+  : TestSuite ("outdoor-random-walk-model", UNIT)
+{
+  AddTestCase (new OutdoorRandomWalkTestCase, TestCase::QUICK);
+}
+
+static OutdoorRandomWalkTestSuite OutdoorRandomWalkTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/wscript ns-3.31/src/buildings/wscript
--- ns-3.30.1/src/buildings/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -11,10 +11,12 @@
         'model/buildings-propagation-loss-model.cc',
         'model/hybrid-buildings-propagation-loss-model.cc',
         'model/oh-buildings-propagation-loss-model.cc',
+        'model/buildings-channel-condition-model.cc',
         'helper/building-container.cc',
         'helper/building-position-allocator.cc',
         'helper/building-allocator.cc',
         'helper/buildings-helper.cc',
+        'model/random-walk-2d-outdoor-mobility-model.cc',
         ]
 
     module_test = bld.create_ns3_module_test_library('buildings')
@@ -23,7 +25,15 @@
         'test/building-position-allocator-test.cc',
         'test/buildings-pathloss-test.cc',
         'test/buildings-shadowing-test.cc',
+        'test/buildings-channel-condition-model-test.cc',
+        'test/outdoor-random-walk-test.cc',
         ]
+
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #   'test/buildings-examples-test-suite.cc',
+            ])
     
     headers = bld(features='ns3header')
     headers.module = 'buildings'
@@ -35,10 +45,12 @@
         'model/buildings-propagation-loss-model.h',
         'model/hybrid-buildings-propagation-loss-model.h',
         'model/oh-buildings-propagation-loss-model.h',
+        'model/buildings-channel-condition-model.h',
         'helper/building-container.h',
         'helper/building-allocator.h',
         'helper/building-position-allocator.h',
         'helper/buildings-helper.h',
+        'model/random-walk-2d-outdoor-mobility-model.h',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
